Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/EstimateInput/FrmEstimateInputAuxiliary.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/EstimateInput/FrmEstimateInputAuxiliary.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/EstimateInput/FrmEstimateInputAuxiliary.cs	(revision 51)
@@ -1,4 +1,5 @@
 ﻿using System;
+using System.Collections;
 using System.Collections.Generic;
 using System.Linq;
 using System.Text;
@@ -268,9 +269,10 @@
                 newpage.EntryDGV.CellDoubleClick += new System.Windows.Forms.DataGridViewCellEventHandler(this.dgvEntryData_CellDoubleClick);
                 newpage.EntryDGV.CellEnter += new System.Windows.Forms.DataGridViewCellEventHandler(this.dgvEntryData_CellEnter);
                 newpage.EntryDGV.CellValidated += new System.Windows.Forms.DataGridViewCellEventHandler(this.dgvEntryData_CellValidated);
-                newpage.EntryDGV.KeyDown += new System.Windows.Forms.KeyEventHandler(this.dgvEntryData_KeyDown);
                 newpage.EntryDGV.CellValueChanged += new DataGridViewCellEventHandler(this.dgvEntryData_CellValueChanged);
                 newpage.EntryDGV.CurrentCellChanged += new System.EventHandler(this.dgvEntryData_CurrentCellChanged);
+                newpage.EntryDGV.Scroll += new System.Windows.Forms.ScrollEventHandler(this.dgvEntryData_Scroll);
+                newpage.EntryDGV.KeyDown += new System.Windows.Forms.KeyEventHandler(this.dgvEntryData_KeyDown);
                 newpage.EntryDGV.MouseUp += new System.Windows.Forms.MouseEventHandler(this.dgvEntryData_MouseUp);
                 // 
                 // Column03
@@ -1083,9 +1085,9 @@
         }
         #endregion
 
-        #region 協力会社名称を取得する
+        #region 協力会社名称を取得する（ＤＢアクセス有）
         /// <summary>
-        /// 協力会社名称を取得する
+        /// 協力会社名称を取得する（ＤＢアクセス有）
         /// </summary>
         /// <param name="SubConstructorCode"></param>
         /// <returns></returns>
@@ -1114,7 +1116,7 @@
             catch (Exception ex)
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
-                return "";
+                return string.Empty;
             }
             finally
             {
@@ -1123,6 +1125,47 @@
         }
         #endregion
 
+        #region 協力会社名称を取得する（ＤＢアクセス無）
+        /// <summary>
+        /// 協力会社名称を取得する（ＤＢアクセス無）
+        /// </summary>
+        /// <param name="SubConstructorCode"></param>
+        /// <returns></returns>
+        private string GetSubConstructorName(int SubConstructorCode, string SubConstrName)
+        {
+            IOMSubContractor scDB = new IOMSubContractor();
+            try
+            {
+                string strName = string.Empty;
+                if (SubConstructorCode == CommonDefine.s_AmountMoney[(int)CommonDefine.AmountMoneyNo.MyCosts].Key)
+                {
+                    // 自社コードは自社名
+                    strName = CommonDefine.s_AmountMoney[(int)CommonDefine.AmountMoneyNo.MyCosts].Value;
+                }
+
+                else if (SubConstructorCode == CommonDefine.s_AmountMoney[(int)CommonDefine.AmountMoneyNo.UnDecided].Key)
+                {
+                    // 業者未定は業者未定
+                    strName = CommonDefine.s_AmountMoney[(int)CommonDefine.AmountMoneyNo.UnDecided].Value;
+                }
+                else
+                {
+                    strName = SubConstrName;
+                }
+                return strName;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return string.Empty;
+            }
+            finally
+            {
+                scDB.close(); scDB = null;
+            }
+        }
+        #endregion
+
         #region 工種・作業タブのセット
         /// <summary>
         /// 工種・作業タブのセット
@@ -1129,7 +1172,7 @@
         /// </summary>
         /// <param name="linecnt"></param>
         /// <param name="Datalist"></param>
-        private void SetItemWorkRowData(int tabcnt, int linecnt, EstimateDataDetail Datalist)
+        private void SetItemWorkRowData(int tabcnt, int linecnt, EstimateDataDetail Datalist, string SubConstr, bool bDBAccess = true)
         {
             DataGridView dgv = m_EntryPage[tabcnt].EntryDGV;
             DataGridViewRow dgvRow = dgv.Rows[linecnt];
@@ -1155,7 +1198,11 @@
 
             // 協力業者セット
             dgvRow.Cells[(int)GridItemColumn.SubConstractorCode].Value = Datalist.CompanyCode;
-            dgvRow.Cells[(int)GridItemColumn.SubConstractorName].Value = GetSubConstructorName(Datalist.CompanyCode);
+            // DBへのアクセスを行わない場合がある
+            if (bDBAccess)
+                dgvRow.Cells[(int)GridItemColumn.SubConstractorName].Value = GetSubConstructorName(Datalist.CompanyCode);
+            else
+                dgvRow.Cells[(int)GridItemColumn.SubConstractorName].Value = GetSubConstructorName(Datalist.CompanyCode, SubConstr);
 
             if (m_EntryPage[tabcnt].Cotegory == CommonDefine.TabCotegory.Component)
             {
@@ -1706,10 +1753,10 @@
                 int iConstructionCode = m_ConstructionBaseInfo.ConstructionCode;
                 int iApprovalCode = ClsExcute.AppovalList.First(x => x.Value.Equals("積算見積書承認")).Key;
                 // 担当部署取得
-                int DepartmentCode = ClsApprovalPermission.GetFromConstructionAndApprovalTheDepartment(m_ConstructionBaseInfo.ConstructionCode, iApprovalCode);
+                int DepartmentCode = ClsApprovalPermission.GetFromConstructionAndApprovalTheDepartment(m_ConstructionBaseInfo.ConstructionCode, iApprovalCode, CommonDefine.s_Default_OrderNo);
 
                 // 承認データ取得
-                int ApprovalCount = ClsApprovalPermission.GetApprovalDataCount(iConstructionCode, iApprovalCode);
+                int ApprovalCount = ClsApprovalPermission.GetApprovalDataCount(iConstructionCode, iApprovalCode, CommonDefine.s_Default_OrderNo);
 
                 // 承認経路マスタ取得
                 int MasterCount = ClsApprovalPermission.GetApprovalMasterCount(iApprovalCode, DepartmentCode);
@@ -1760,7 +1807,7 @@
                 btnPetition.Size = new Size(250, btnPetition.Size.Height);
 
                 // ----- 工事コード・承認機能番号取得（申請レコードがなお場合は未申請）
-                if (!ClsApprovalPermission.CheckPetition(m_ConstructionCode, iApprovalCode)) return;
+                if (!ClsApprovalPermission.CheckPetition(m_ConstructionCode, iApprovalCode, CommonDefine.s_Default_OrderNo)) return;
 
                 // ----- 申請済の場合
                 // 申請ボタンの表示
@@ -1773,12 +1820,14 @@
                 btnApproval.Visible = true;
 
                 // ----- 承認済の場合
-                if (ClsApprovalPermission.CheckApproval(m_ConstructionCode, iApprovalCode))
+                if (ClsApprovalPermission.CheckApproval(m_ConstructionCode, iApprovalCode, CommonDefine.s_Default_OrderNo))
                 {
                     btnApproval.Text = CommonDefine.ApprovalButtonString[1];
                     btnApproval.ForeColor = Color.Black;
                     // 承認済みの場合は入力できない
                     EstimaiteInputReadOnly();
+                    // 承認済みフラグON
+                    m_ApprovalFlag = true;
                 }
 
                 // 承認件数の表示
@@ -1817,6 +1866,8 @@
                 btnDispUp.Visible = false;                          // 行アップボタン
                 btnDispDown.Visible = false;                        // 行ダウンボタン
                 btnMasterIn.Visible = false;                        // 小項目マスタ追加ボタン
+                // タブ閉じるボタン非表示
+                TabCollections.DrawButton = false;
             }
             catch (Exception ex)
             {
@@ -1879,9 +1930,8 @@
         /// <param name="Code"></param>
         /// <param name="Amount"></param>
         /// <param name="AmountList"></param>
-        private void AddAmountList(int Code, int Amount)
+        private void AddAmountList(int Code, int Amount, string CompanyName)
         {
-            IOMSubContractor scDB = new IOMSubContractor();
             try
             {
                 bool bExistFlg = false;
@@ -1903,12 +1953,8 @@
                 dataRec.DispNo = NoCnt;
                 dataRec.Code = Code;
                 dataRec.Amount = Amount;
+                dataRec.Name = CompanyName;
 
-                // 未割当・自社はここまで来ない
-                string strSQL = scDB.CreatePrimarykeyString(Code);
-                SubContractorMaster scRec = new SubContractorMaster();
-                if (scDB.SelectAction(strSQL, ref scRec)) dataRec.Name = scRec.CompanyName;
-
                 m_AmountList.Add(dataRec);
             }
             catch (Exception ex)
@@ -1915,10 +1961,6 @@
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
-            finally
-            {
-                scDB.close(); scDB = null;
-            }
         }
 
         #endregion
@@ -1948,6 +1990,7 @@
                         if (CommonMotions.chkCellBlank(wrkRow.Cells[(int)GridItemColumn.LineTotal].Value)) continue;
 
                         int Code = 0;
+                        string CompanyName = string.Empty;
                         // 金額は共通なので先に取得する
                         int Amount = CommonMotions.cnvInt(wrkRow.Cells[(int)GridItemColumn.LineTotal].Value);
 
@@ -1955,7 +1998,10 @@
                         if (wrkPage.Cotegory == CommonDefine.TabCotegory.Item)
                         {   // 割当会社を取得する
                             if (!CommonMotions.chkObjectIsNull(wrkRow.Cells[(int)GridItemColumn.SubConstractorCode].Value))
+                            {
                                 Code = CommonMotions.cnvInt(wrkRow.Cells[(int)GridItemColumn.SubConstractorCode].Value);
+                                CompanyName = CommonMotions.cnvString(wrkRow.Cells[(int)GridItemColumn.SubConstractorName].Value);
+                            }
                         }
                         // 中項目の計算
                         else if (wrkPage.Cotegory == CommonDefine.TabCotegory.Component)
@@ -1966,7 +2012,10 @@
 
                             // 割当会社を取得する
                             if (!CommonMotions.chkObjectIsNull(wrkRow.Cells[(int)GridComponentColumn.SubConstractorCode].Value))
+                            {
                                 Code = CommonMotions.cnvInt(wrkRow.Cells[(int)GridItemColumn.SubConstractorCode].Value);
+                                CompanyName = CommonMotions.cnvString(wrkRow.Cells[(int)GridItemColumn.SubConstractorName].Value);
+                            }
 
                             // 割当が無く経費だった場合
                             if (!CommonMotions.chkObjectIsNull(wrkRow.Cells[(int)GridComponentColumn.ExpensesFlg].Value))
@@ -2000,7 +2049,7 @@
                             }
                         }
                         // 金額加算
-                        AddAmountList(Code, Amount);
+                        AddAmountList(Code, Amount, CompanyName);
                     }
                 }
 
@@ -2779,7 +2828,7 @@
                     //etdwork.UnitPrice = UnitPriceArray[ix];
                     etdwork.LineTotal = 0;
 
-                    SetItemWorkRowData(TabCnt, CurrentRow, etdwork);
+                    SetItemWorkRowData(TabCnt, CurrentRow, etdwork, string.Empty);
                     CurrentRow++;
                 }
 
@@ -3508,7 +3557,7 @@
                 if (PageCotegory == CommonDefine.TabCotegory.Total)
                     SetRowData(CurrentTabCnt, CurrentRow, Data);
                 else
-                    SetItemWorkRowData(CurrentTabCnt, CurrentRow, Data);
+                    SetItemWorkRowData(CurrentTabCnt, CurrentRow, Data, string.Empty);
 
                 // 行カウントアップ
                 CurrentRow++;
@@ -4433,19 +4482,21 @@
         private bool LargeDataDisplay()
         {
             IOEstimateData etDB = new IOEstimateData();
-            IOMComponent MctDB = new IOMComponent();
+            IOEstimateDataDetail detailDB = new IOEstimateDataDetail();
+            //IOMComponent MctDB = new IOMComponent();
 
             List<EstimateData> LargeList = new List<EstimateData>();
             try
             {
                 // ++++++++++++++++++++++++++++++++++++++++ 積算見積データ
-
                 // 積算見積データ取得
-                string strSQL = etDB.CreatePrimarykeyString(m_ConstructionCode) + " Order By LineCount";
-                if (!etDB.SelectAction(strSQL, ref LargeList)) return false;
+                ArrayList LargeDataList = new ArrayList();
+                string strSQL = "SELECT A.*, B.* FROM ESTIMATEDATA A LEFT JOIN COMPONENTMASTER B ON B.COMPONENTCODE = A.COMPONENTCODE";
+                strSQL += string.Format(" WHERE A.CONSTRUCTIONCODE = {0} ORDER BY A.LineCount",m_ConstructionCode);
+                if (!etDB.ExecuteReader(strSQL, ref LargeDataList)) return false;
 
                 // データ無は表示せずに入力へ
-                if (LargeList.Count == 0) return false;
+                if (LargeDataList.Count == 0) return false;
 
                 // ページカテゴリセット
                 m_EntryPage[0].Cotegory = CommonDefine.TabCotegory.Total;
@@ -4452,24 +4503,30 @@
 
                 int CurrentRow = 0;
 
+                EstimateDataDetail DetailRec = new EstimateDataDetail();
+                List<ComponentMaster> CompList = new List<ComponentMaster>();
+
                 // データグリッドオブジェクト取得
+                SetArraryList2StructDataType1(LargeDataList, ref LargeList, ref CompList);
                 // 行を作成する
                 for (int iy = 0; iy < LargeList.Count; iy++)
                 {
+
                     // 固定行は処理しない
                     double dwork = 0;
                     if (!CommonMotions.chkNumeric(LargeList[iy].FixedItemCode, ref dwork)) continue;
 
-                    //// 行データセット
-                    EstimateDataDetail DataList = new EstimateDataDetail();
+                    // 構造体クリア
+                    detailDB.ClearStruct(ref DetailRec);
 
-                    DataList.ConstructionCode = LargeList[iy].ConstructionCode;
-                    DataList.ComponentCode = LargeList[iy].ComponentCode;
-                    DataList.ItemName = LargeList[iy].ItemName;
-                    DataList.UnitCount = 1.0;
-                    DataList.UnitName = "式";
-                    DataList.LineTotal = LargeList[iy].PriceValue;
-                    DataList.Note = LargeList[iy].Note;
+                    // 行データセット(構成データより項目データへセットする)
+                    DetailRec.ConstructionCode = LargeList[iy].ConstructionCode;
+                    DetailRec.ComponentCode = LargeList[iy].ComponentCode;
+                    DetailRec.ItemName = LargeList[iy].ItemName;
+                    DetailRec.UnitCount = 1.0;
+                    DetailRec.UnitName = "式";
+                    DetailRec.LineTotal = LargeList[iy].PriceValue;
+                    DetailRec.Note = LargeList[iy].Note;
 
 
                     // ++++++++++++++++++++ 行の追加
@@ -4479,26 +4536,21 @@
                     SetRowClearData(dgvEntryData, CurrentRow);
 
                     // 行データセット
-                    SetRowData(0, iy, DataList);
+                    SetRowData(0, iy, DetailRec);
 
                     int iExpensesFlg = LargeList[iy].MyExpensesFlg;
                     int iInputFlg = LargeList[iy].InputFlg;
 
                     // マスタにデータがあればそちらを優先する
-                    string strComponent = MctDB.CreatePrimarykeyString(LargeList[iy].ComponentCode);
-                    ComponentMaster MctRec = new ComponentMaster();
-                    if (MctDB.SelectAction(strComponent, ref MctRec))
-                    {
-                        // 経費フラグをセット
-                        iExpensesFlg = MctRec.MyExpensesFlg;
+                    // 経費フラグをセット
+                    iExpensesFlg = CompList[iy].MyExpensesFlg;
 
-                        // 下位に項目が無ければ直接入力
-                        if (MctRec.SubitemsFlg == 0) iInputFlg = 1;
-                        else iInputFlg = 0;
+                    // 下位に項目が無ければ直接入力
+                    if (CompList[iy].SubitemsFlg == 0) iInputFlg = 1;
+                    else iInputFlg = 0;
 
-                        // 直接入力フラグがOnの場合は直接入力可能をOnにする
-                        if (MctRec.DirectInputFlg == 1) iInputFlg = 1;
-                    }
+                    // 直接入力フラグがOnの場合は直接入力可能をOnにする
+                    if (CompList[iy].DirectInputFlg == 1) iInputFlg = 1;
 
                     // ----- 入力許可フラグと自社経費フラグを見えないセルに持つ
                     dgvEntryData.Rows[CurrentRow].Cells[(int)GridTotalColumn.ExpensesFlg].Value = iExpensesFlg;
@@ -4528,11 +4580,66 @@
                 InitDispTotalPage(LargeList);
 
                 etDB.close(); etDB = null;
-                MctDB.close(); MctDB = null;
+                detailDB.close(); detailDB = null;
+                //MctDB.close(); MctDB = null;
             }
         }
         #endregion
 
+        #region ArraryListよりデータ構造体配列へセットする（大項目）
+        /// <summary>
+        /// ArraryListよりデータ構造体配列へセットする（大項目）
+        /// </summary>
+        /// <param name="DataList"></param>
+        /// <param name="LargeList"></param>
+        /// <param name="CompList"></param>
+        private void SetArraryList2StructDataType1(ArrayList DataList,
+                                                    ref List<EstimateData> LargeList,
+                                                    ref List<ComponentMaster> CompList)
+        {
+            try
+            {
+                int EstimateCnt = Enum.GetNames(typeof(IOEstimateData.TableColumn)).Length;
+
+                foreach (object[] objRec in DataList)
+                {
+                    // 積算見積書データセット
+                    EstimateData LargeRec = new EstimateData();
+                    LargeRec.ConstructionCode = CommonMotions.cnvInt(objRec[(int)IOEstimateData.TableColumn.ConstructionCode]);     // 工事番号
+                    LargeRec.LineCount = CommonMotions.cnvInt(objRec[(int)IOEstimateData.TableColumn.LineCount]);                   // 行番号
+                    LargeRec.ComponentCode = CommonMotions.cnvInt(objRec[(int)IOEstimateData.TableColumn.ComponentCode]);           // 構成キー
+                    LargeRec.FixedItemCode = CommonMotions.cnvString(objRec[(int)IOEstimateData.TableColumn.FixedItemCode]);        // 固定項目キー
+                    LargeRec.ItemName = CommonMotions.cnvString(objRec[(int)IOEstimateData.TableColumn.ItemName]);                  // 作業名称
+                    LargeRec.WorkName = CommonMotions.cnvString(objRec[(int)IOEstimateData.TableColumn.WorkName]);                  // 工種名称／規格・寸法名称
+                    LargeRec.PriceValue = CommonMotions.cnvDouble(objRec[(int)IOEstimateData.TableColumn.PriceValue]);              // 金額
+                    LargeRec.Note = CommonMotions.cnvString(objRec[(int)IOEstimateData.TableColumn.Note]);                          // 備考
+                    LargeRec.MyExpensesFlg = CommonMotions.cnvInt(objRec[(int)IOEstimateData.TableColumn.MyExpensesFlg]);           // 自社経費フラグ
+                    LargeRec.InputFlg = CommonMotions.cnvInt(objRec[(int)IOEstimateData.TableColumn.InputFlg]);                     // 入力フラグ
+                    LargeRec.EntryDate = CommonMotions.cnvDate(objRec[(int)IOEstimateData.TableColumn.EntryDate]);                  // 登録日付
+                    LargeRec.UpdateDate = CommonMotions.cnvDate(objRec[(int)IOEstimateData.TableColumn.UpdateDate]);                // 更新日付
+                    LargeList.Add(LargeRec);
+
+                    // 構成データセット
+                    ComponentMaster CompRec = new ComponentMaster();
+                    CompRec.ComponentCode = CommonMotions.cnvInt(objRec[EstimateCnt + (int)IOMComponent.NameColumn.ComponentCode]);     // 構成キー
+                    CompRec.DisplayOrder = CommonMotions.cnvInt(objRec[EstimateCnt + (int)IOMComponent.NameColumn.DisplayOrder]);	    // 表示順
+                    CompRec.ComponentName = CommonMotions.cnvString(objRec[EstimateCnt + (int)IOMComponent.NameColumn.ComponentName]);	// 名称
+                    CompRec.SubitemsFlg = CommonMotions.cnvInt(objRec[EstimateCnt + (int)IOMComponent.NameColumn.SubitemsFlg]);	        // 下位項目フラグ
+                    CompRec.DirectInputFlg = CommonMotions.cnvInt(objRec[EstimateCnt + (int)IOMComponent.NameColumn.DirectInputFlg]);	// 直接入力フラグ
+                    CompRec.MyExpensesFlg = CommonMotions.cnvInt(objRec[EstimateCnt + (int)IOMComponent.NameColumn.MyExpensesFlg]);	    // 自社経費フラグ
+                    CompRec.DeleteFlg = CommonMotions.cnvInt(objRec[EstimateCnt + (int)IOMComponent.NameColumn.DeleteFlg]);	            // 削除フラグ
+                    CompRec.EntryDate = CommonMotions.cnvDate(objRec[EstimateCnt + (int)IOMComponent.NameColumn.EntryDate]);            // 登録日付
+                    CompRec.UpdateDate = CommonMotions.cnvDate(objRec[EstimateCnt + (int)IOMComponent.NameColumn.UpdateDate]);          // 更新日付
+                    CompList.Add(CompRec);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
         #region 中・小項目タブ表示
         /// <summary>
         /// 中・小項目タブ表示
@@ -4542,7 +4649,6 @@
         {
             IOEstimateDataBody etbDB = new IOEstimateDataBody();
             IOEstimateDataDetail etdDB = new IOEstimateDataDetail();
-            IOMComponent MctDB = new IOMComponent();
             IOMConstructionItem MciDB = new IOMConstructionItem();
             IOMComponentLink linkDB = new IOMComponentLink();
 
@@ -4552,14 +4658,29 @@
                 List<EstimateDataBody> MiddleList = new List<EstimateDataBody>();
 
                 // 積算見積ページデータ取得
-                string strSQL = etbDB.CreatePrimarykeyString(m_ConstructionCode) + " Order By PageCount";
-                if (!etbDB.SelectAction(strSQL, ref MiddleList)) return false;
+                //string strSQL = etbDB.CreatePrimarykeyString(m_ConstructionCode) + " Order By PageCount";
+                //if (!etbDB.SelectAction(strSQL, ref MiddleList)) return false;
+                string strSQL = "SELECT A.*, B.CNT, B.COMPONENTCODE FROM ESTIMATEDATABODY A,";
+                strSQL += " (SELECT COMPONENTCODE, COUNT(*) CNT FROM COMPONENTLINKMASTER BB";
+                strSQL += " WHERE BB.COMPONENTCODE IN (SELECT BBB.COMPONENTCODE FROM ESTIMATEDATABODY BBB";
+                strSQL += string.Format(" WHERE BBB.CONSTRUCTIONCODE = {0}) GROUP BY BB.COMPONENTCODE) B", m_ConstructionCode);
+                strSQL += string.Format(" WHERE A.CONSTRUCTIONCODE = {0}",m_ConstructionCode);
+                strSQL += " AND B.COMPONENTCODE = A.COMPONENTCODE";
+                strSQL += " ORDER BY A.PAGECOUNT";
+                ArrayList MiddleDataList = new ArrayList();
+                if (!etbDB.ExecuteReader(strSQL, ref MiddleDataList)) return false;
 
                 // データ無は次処理
-                if (MiddleList.Count == 0) return true;
+                if (MiddleDataList.Count == 0) return true;
 
                 int MiddleTab = 0;
                 int CnvCode = 0;
+                List<KeyValuePair<int, int>> linkList = new List<KeyValuePair<int, int>>();
+                List<EstimateDataDetail> SmallList = new List<EstimateDataDetail>();
+                List<ConstructionItemMaster> MciList = new List<ConstructionItemMaster>();
+                List<string> SubConstr = new List<string>();
+                // データセット
+                SetArraryList2StructDataType2(MiddleDataList, ref MiddleList, ref linkList);
                 for (int ix = 0; ix < MiddleList.Count; ix++)
                 {
                     // 工種タブカウントアップ
@@ -4568,23 +4689,16 @@
                     //// 行データセット
                     EstimateDataDetail DataListD = new EstimateDataDetail();
 
-                    if (ix != 0
-                        && (CommonDefine.TabCotegory)MiddleList[ix].Category == CommonDefine.TabCotegory.Component)
+                    bool subItems = true;
+                    if (MiddleList[ix].Category == (int)CommonDefine.TabCotegory.Component)
                     {
                         // 構成タブのみ行番号の英字キャラクタカウント
-                        ++CnvCode;
+                        if (ix != 0) ++CnvCode;
+
+                        // 構成タブの場合のみ下位にデータがあるかをチェックする
+                        if (linkList[ix].Key == 0) subItems = false;
                     }
-                    // 構成タブの場合のみ下位にデータがあるかをチェックする
-                    bool subItems = true;
-                    if ((CommonDefine.TabCotegory)MiddleList[ix].Category == CommonDefine.TabCotegory.Component)
-                    {
-                        string strLink = linkDB.CreatePrimarykeyString(MiddleList[ix].ComponentCode);
-                        List<ComponentLinkMaster> linkList = new List<ComponentLinkMaster>();
-                        if (linkDB.SelectAction(strLink, ref linkList) && linkList.Count == 0)
-                        {
-                            subItems = false;
-                        }
-                    }
+
                     // 新規：タブ追加
                     CreateTab((CommonDefine.TabCotegory)MiddleList[ix].Category,
                                     MiddleList[ix].ComponentCode,
@@ -4602,14 +4716,23 @@
 
 
                     // ++++++++++++++++++++++++++++++++++++++++ 積算見積明細データ(作業)
-                    List<EstimateDataDetail> SmallList = new List<EstimateDataDetail>();
+                    SmallList.Clear();
+                    MciList.Clear();
+                    SubConstr.Clear();
+                    
                     // 積算見積データ取得
-                    strSQL = etdDB.CreatePrimarykeyString(MiddleList[ix].ConstructionCode, MiddleList[ix].PageCount) + " Order By PageCount, LineCount";
-                    if (!etdDB.SelectAction(strSQL, ref SmallList)) continue;
+                    strSQL = "SELECT A.*, B.*, C.COMPANYNAME FROM ESTIMATEDATADETAIL A";
+                    strSQL += " LEFT JOIN CONSTRUCTIONITEMMASTER B ON B.ITEMCODE = A.ITEMCODE";
+                    strSQL += " LEFT JOIN SUBCONTRACTORMASTER C ON C.COMPANYCODE = A.COMPANYCODE";
+                    strSQL += string.Format(" WHERE A.CONSTRUCTIONCODE = {0} AND A.PAGECOUNT = {1}", MiddleList[ix].ConstructionCode, MiddleList[ix].PageCount);
+                    strSQL += " Order By A.PAGECOUNT, A.LINECOUNT";
+                    ArrayList SmallDataList = new ArrayList();
+                    if (!etdDB.ExecuteReader(strSQL, ref SmallDataList)) continue;
 
                     // データ無は次処理
-                    if (SmallList.Count == 0) continue;
-
+                    if (SmallDataList.Count == 0) continue;
+                    // データセット
+                    SetArraryList2StructDataType3(SmallDataList, ref SmallList, ref MciList, ref SubConstr);
                     int SmallRow = 0;
                     // グリッド表示停止
                     m_EntryPage[MiddleTab].EntryDGV.SuspendLayout();
@@ -4618,7 +4741,6 @@
                     for (int iy = 0; iy < SmallList.Count; iy++)
                     {
                         // 行追加
-                        //CreateNewLine(m_EntryPage[MiddleTab].EntryDGV, ref SmallRow);
                         DataGridViewAction.CreateNewLine(m_EntryPage[MiddleTab].EntryDGV, ref SmallRow);
 
                         // クリアデータセット
@@ -4631,25 +4753,20 @@
                             if (SmallList[iy].ItemCode == 0) SmallList[iy].InputFlg = 1;
 
                             // マスタにデータがあればそちらを優先する
-                            string strItem = MciDB.CreatePrimarykeyString(SmallList[iy].ItemCode);
-                            ConstructionItemMaster MciRec = new ConstructionItemMaster();
-                            if (MciDB.SelectAction(strItem, ref MciRec))
-                            {
-                                // 経費フラグをセット
-                                SmallList[iy].MyExpensesFlg = MciRec.MyExpensesFlg;
+                            // 経費フラグをセット
+                            SmallList[iy].MyExpensesFlg = MciList[iy].MyExpensesFlg;
 
-                                // 下位に項目が無ければ直接入力
-                                if (MciRec.SubitemsFlg == 0) SmallList[iy].InputFlg = 1;
-                                else SmallList[iy].InputFlg = 0;
-                            }
+                            // 下位に項目が無ければ直接入力
+                            if (MciList[iy].SubitemsFlg == 0) SmallList[iy].InputFlg = 1;
+                            else SmallList[iy].InputFlg = 0;
                         }
                         // 行データセット
-                        SetItemWorkRowData(MiddleTab, SmallRow, SmallList[iy]);
+                        SetItemWorkRowData(MiddleTab, SmallRow, SmallList[iy], SubConstr[iy], false);
                         SmallRow++;
                     }
 
                     // 構成タブで下位にデータが無い場合のみナンバリング
-                    if ((CommonDefine.TabCotegory)MiddleList[ix].Category == CommonDefine.TabCotegory.Component && m_EntryPage[MiddleTab].SubItems)
+                    if (MiddleList[ix].Category == (int)CommonDefine.TabCotegory.Component && m_EntryPage[MiddleTab].SubItems)
                     {
                         // 下位にデータがある場合のみリナンバする
                         LineReNumbering(m_EntryPage[MiddleTab].EntryDGV);
@@ -4674,7 +4791,6 @@
 
                 etdDB.close(); etdDB = null;
 
-                MctDB.close(); MctDB = null;
                 MciDB.close(); MciDB = null;
                 linkDB.close(); linkDB = null;
             }
